### Method

# Gio InputStream read_all_finish

since: 2.44

#### Declaration [src]

    gboolean
    g_input_stream_read_all_finish (
      GInputStream* stream,
      GAsyncResult* result,
      gsize* bytes_read,
      GError** error
    )

#### Description [src]

Finishes an asynchronous stream read operation started with `g_input_stream_read_all_async()`.

As a special exception to the normal conventions for functions that use `GError`, if this function returns `FALSE` (and sets `error`) then `bytes_read` will be set to the number of bytes that were successfully read before the error was encountered. This functionality is only available from C. If you need it from another language then you must write your own loop around g_input_stream_read_async().

Available since: 2.44

#### Parameters

`result`

  Type: `GAsyncResult`

  A `GAsyncResult`.

  The data is owned by the caller of the method.

`bytes_read`

  Type: `gsize*`

  Location to store the number of bytes that was read from the stream.

  The argument will be set by the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` on success, `FALSE` if there was an error.